# -*- coding:Latin-1 -*-
# Script initial de Yannick Mayot, boite de dialogue modifie par Daniel Poiraud, AVH16
import globalPluginHandler
import wx
from ctypes import windll  
from oleacc import AccessibleObjectFromWindow, STATE_SYSTEM_INVISIBLE 
from time import sleep
from sys import getwindowsversion
from winUser import *  

lastWindow=1  
nextWindow=2
firstChild=5

class ListeNotification(wx.Dialog):
    def __init__(self):
        wx.Dialog.__init__(self, None, title="Slectionnez une icne de la zone de notification",size=(500, 260))      
        panel = wx.Panel(self)
        allbox = wx.BoxSizer(wx.HORIZONTAL)
        vbox1 = wx.BoxSizer(wx.VERTICAL)        
        vbox2 = wx.BoxSizer(wx.VERTICAL)
        box = wx.StaticBox(panel,-1,"&Liste des icnes")
        box1 = wx.StaticBoxSizer(box,wx.VERTICAL)
        self.listeIcones = wx.ListBox(panel, wx.ID_ANY, size =(325,175))
        BoutonClicDroit=wx.Button(panel, 21, label ='Simple clic &droit', size = (125,25)) #wx.ID_ANY, 
        BoutonClicGauche=wx.Button(panel, 22, label ='Simple clic &gauche', size = (125,25)) 
        BoutonDoubleGauche=wx.Button(panel,23, label = 'Dou&ble clic gauche', size = (125,25))  
        BoutonAnnuler=wx.Button(panel,wx.ID_CANCEL, size = (125,25))    
        box1.Add(self.listeIcones, wx.ALL|wx.EXPAND, 5)
        vbox1.Add(box1)
        vbox2.Add((-1,10))
        vbox2.Add(BoutonClicDroit,wx.ALIGN_RIGHT|wx.ALL, 20)
        vbox2.Add((-1,15))
        vbox2.Add(BoutonClicGauche,wx.ALIGN_RIGHT|wx.ALL, 20)
        vbox2.Add((-1,15))
        vbox2.Add(BoutonDoubleGauche,wx.ALIGN_RIGHT|wx.ALL, 20)
        vbox2.Add((-1,15))
        vbox2.Add(BoutonAnnuler,wx.ALIGN_RIGHT|wx.ALL, 20)
        allbox.Add(vbox1,1, wx.EXPAND)
        allbox.Add(vbox2,1, wx.ALL, 20)  # wx.EXPAND 
        panel.SetSizerAndFit(allbox)
        BoutonClicDroit.SetDefault()
        self.Bind(wx.EVT_BUTTON, self.rightMouseButton, id = 21)
        self.Bind(wx.EVT_BUTTON,self.leftClick, id = 22) 
        self.Bind(wx.EVT_BUTTON,self.doubleLeftClick, id = 23)
        setForegroundWindow(self.GetHandle())
        hd0=windll.user32.FindWindowExA(None,None,"Shell_TrayWnd",None) 
        getWindow =windll.user32.GetWindow
        hdVista = getWindow(getWindow(getWindow(getWindow(hd0,firstChild),firstChild),nextWindow),firstChild)
        hdW7 = getWindow(getWindow(getWindow(getWindow(getWindow(hd0,firstChild),firstChild),nextWindow),nextWindow),firstChild)
        hdXP = getWindow(getWindow(getWindow(getWindow(getWindow(hd0,firstChild),nextWindow),firstChild),nextWindow),firstChild)
        version = getwindowsversion()
        if version[0]==6 and version[1]==0:
            hd = hdVista
        elif version[0]==6 and version[1]==1:
            hd = hdW7
        else:
            hd = hdXP
        self.oListe=AccessibleObjectFromWindow(hd,-4)
        location,self.PositionXY=None,[]
        max=self.oListe.accChildCount
        name=""
        l=[]
        for i in range (1,max+1):
            if (self.oListe.accState(i)&STATE_SYSTEM_INVISIBLE):
                continue
            name =self.oListe.accName(i)
            if name:
                location=self.oListe.accLocation(i)
                location=(location[0]+location[2]/2,location[1]+location[3]/2)
                self.PositionXY.append(location)
                l.append(name)
        max=" sur "+str(len(l))
        for i in range (len(l)):
			      l[i]=l[i]+". "+str (i+1)+max
        self.listeIcones.AppendItems(l)
        self.listeIcones.Select(0)		
        self.listeIcones.SetFocus()

    def getPositionXY (self):
        itemSelected=self.listeIcones.GetSelection()
        xyItem=self.PositionXY[itemSelected]
        return xyItem  
   
    def leftClick (self,event):
        self.BoutonGaucheSouris(1)

    def rightMouseButton(self,event):
        (x,y)=self.getPositionXY()
        self.Close()
        setCursorPos(x,y)
        mouse_event(MOUSEEVENTF_RIGHTDOWN,0,0,None,None)
        sleep(0.01)
        mouse_event(MOUSEEVENTF_RIGHTUP,0,0,None,None)

    def BoutonGaucheSouris(self,nb):
        self.Close()
        (x,y)=self.getPositionXY()
        setCursorPos(x,y)
        for i in range(nb):
            mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,None,None)
            mouse_event(MOUSEEVENTF_LEFTUP,0,0,None,None)
        
    def doubleLeftClick (self,event):
        self.BoutonGaucheSouris(2)

    def launchApp(self,event):
        self.BoutonGaucheSouris(1)     


class GlobalPlugin(globalPluginHandler.GlobalPlugin):

    def script_ListesAppliIcones(self,gesture):
        hwnd = user32.FindWindowExA(None,None, "#32770","Slectionnez une icne de la zone de notification")
        if hwnd:
            setForegroundWindow(hwnd)
            sendMessage(hwnd,0x0010,0,0)
            sleep(0.05)
        dlg=ListeNotification()
        dlg.CenterOnScreen()
        dlg.Show (True)
        
    # Documentation
    script_ListesAppliIcones.__doc__=_(u"Affiche la liste des icnes de la zone de notification par la commande NVDA+F11.")

    __gestures={
            "kb:nvda+F11":"ListesAppliIcones",
        }

